searchNodes=[{"doc":"Rewire is a libary for replacing hard-wired dependencies of the module your unit testing. This allows you to keep your production code free of any unit testing-specific concerns.Exampledefmodule Conversation do def start(), do: English.greet() # the dependency is hard-wired endYou can rewire the dependency with a mock, using mox for example:defmodule MyTest do use ExUnit.Case use Rewire import Mox rewire Conversation, English: Mock # acts as an alias to the rewired module test &quot;greet&quot; do stub(Mock, :greet, fn -&gt; &quot;bonjour&quot; end) assert Conversation.start() == &quot;bonjour&quot; # this uses Mock now! end enddefmodule MyTest do use ExUnit.Case use Rewire import Mox rewire Conversation, English: Mock # acts as an alias to the rewired module test &quot;greet&quot; do stub(Mock, :greet, fn -&gt; &quot;bonjour&quot; end) assert Conversation.start() == &quot;bonjour&quot; # this uses Mock now! end endAlternatively, you can also rewire a module on a test-by-test basis:defmodule MyTest do use ExUnit.Case use Rewire import Mox test &quot;greet&quot; do rewire Conversation, English: Mock do # within the block it is rewired stub(Mock, :greet, fn -&gt; &quot;bonjour&quot; end) assert Conversation.start() == &quot;bonjour&quot; # this uses Mock now! end end endYou can also give the alias a different name using as: rewire Conversation, English: Mock, as: SmallTalk","ref":"Rewire.html","title":"Rewire","type":"module"},{"doc":"Macro that allows to rewire (and alias) a module.use Rewire rewire App.ModuleToRewire, ModuleDep: Mock # `ModuleToRewire` will use `Mock` now endOptionsopts is a keyword list:as - give the rewired module a different nameany other item, like ModuleDep: Mock, will be interpreted as a mapping from one module to another","ref":"Rewire.html#rewire/2","title":"Rewire.rewire/2","type":"macro"},{"doc":"Macro that allows to rewire a module within a block.use Rewire rewire App.ModuleToRewire, ModuleDep: Mock do # `ModuleToRewire` will use `Mock` now endSee rewire/2 for a description of options.","ref":"Rewire.html#rewire/3","title":"Rewire.rewire/3","type":"macro"},{"doc":"","ref":"Rewire.Alias.html","title":"Rewire.Alias","type":"module"},{"doc":"","ref":"Rewire.Alias.html#rewire_alias/3","title":"Rewire.Alias.rewire_alias/3","type":"function"},{"doc":"","ref":"Rewire.Block.html","title":"Rewire.Block","type":"module"},{"doc":"","ref":"Rewire.Block.html#rewire_block/3","title":"Rewire.Block.rewire_block/3","type":"function"},{"doc":"","ref":"Rewire.Block.html#rewire_block/4","title":"Rewire.Block.rewire_block/4","type":"function"},{"doc":"","ref":"Rewire.Module.html","title":"Rewire.Module","type":"module"},{"doc":"","ref":"Rewire.Module.html#rewire_module/2","title":"Rewire.Module.rewire_module/2","type":"function"},{"doc":"","ref":"Rewire.Utils.html","title":"Rewire.Utils","type":"module"},{"doc":"","ref":"Rewire.Utils.html#gen_new_module_ast/1","title":"Rewire.Utils.gen_new_module_ast/1","type":"function"},{"doc":"","ref":"Rewire.Utils.html#module_ast_to_name/1","title":"Rewire.Utils.module_ast_to_name/1","type":"function"},{"doc":"","ref":"Rewire.Utils.html#module_name_to_ast/1","title":"Rewire.Utils.module_name_to_ast/1","type":"function"},{"doc":"","ref":"Rewire.Utils.html#module_to_ast/1","title":"Rewire.Utils.module_to_ast/1","type":"function"},{"doc":"","ref":"Rewire.Utils.html#module_to_name/1","title":"Rewire.Utils.module_to_name/1","type":"function"},{"doc":"","ref":"Rewire.Utils.html#parse_opts/2","title":"Rewire.Utils.parse_opts/2","type":"function"},{"doc":"","ref":"Rewire.Utils.html#resolve_alias/2","title":"Rewire.Utils.resolve_alias/2","type":"function"}]